<?php

/* $Id: PageMetatags.class.php 2012-09-12 16:15 Rolland $ */

class PageMetatags{
    // для json-ответа 
    var $response=array();
    // для json ошибок
    var $errors=array();
    
    var $my_settings = array();
    var $module_data = null;
    
    public function __construct($my_settings = array(),$load_data = false){
        global $nc_core;
        if(!empty($my_settings)){
            foreach($this->my_settings as $key=>$value){
                $this->my_settings[$key] = rtrim($value,'_ ');    
            }
            $this->my_settings = $my_settings;
        }
        if($load_data){
            $sel_query = "SELECT * FROM `Module` WHERE Keyword = 'page_metatags'" ;
            $this->module_data = $nc_core->db->get_row($sel_query);    
        }
    }
    # вывод формы настройки
    public function ShowSettings(){
        global $UI_CONFIG, $SUB_FOLDER, $nc_core,$MODULE_FOLDER;
        // вытаскиваем список классов (компонентов)
        $structuredClassList = $this->getStructuredClassList();
        // вытаскиваем список полей компонентов
        $fieldsList = $this->getStructuredFieldsList();
        // вытаскиваем сохраненные настройки
        $savedSettings = $this->getSevedSettings() ;
        include($MODULE_FOLDER."page_metatags/settings_form.php");    
    }
    # функция записи информации в базу
    public function SaveSettings() {
        global $nc_core;
        $class_field = $_POST['class_field'];
        if(empty($class_field)){
            $class_field = array();
        }
        // проверяем, что для класса указано его собственное поле
        /*foreach($class_field as $class_ID=>$field_ID){
            // это ж админка. нафига?    
        } */
        // сносим все старые настройки
        $del_query = "DELETE FROM `PageMetatags_Settings`" ;
        $nc_core->db->query($del_query);
        foreach($class_field as $class_ID=>$field_ID){
            $field_ID = (int)$field_ID;
            if(!empty($field_ID) && !empty($class_ID)){
                $ins_query = "INSERT INTO `PageMetatags_Settings` (`Class_ID`,`Field_ID`) VALUES ('".$class_ID."','".$field_ID."') ";
                $nc_core -> db-> query($ins_query);    
            }
        }
        return true;
    }   
    // проверяет на ошибки и выводит ответ либо ошибки
    public function _echo_response(){
        if(empty($this->errors))
        {
            $this->response['success']=true;
        }else{
            $this->_make_errors();
        }
        header('Content-type: application/json');
        echo json_encode($this->response);
        exit();
    }
    // чистит массив ответа и склеивает строку ошибок 
    protected function _make_errors(){
        $this->response=array();
        $this->response['message']='';
        foreach($this->errors as $err){
            $this->response['message'].=$err."\n";
        }
    }
    // получаем название поля (латинское) по ID
    protected function getFieldNameById($fieldID){
        global $nc_core;
        $sel_query = "SELECT `Field_Name` FROM `Field` WHERE Field_ID = ".$fieldID;
        return $nc_core->db->get_var($sel_query);        
    }
    // получаем объект поля по ID
    protected function getFieldById($fieldID){
        global $nc_core;
        $sel_query = "SELECT *,`Classificator_TypeOfData`.`TypeOfData_Name` 
        FROM `Field`
        JOIN `Classificator_TypeOfData` ON `Field`.`TypeOfData_ID` = `Classificator_TypeOfData`.`TypeOfData_ID`
        WHERE Field_ID = ".$fieldID;
        return $nc_core->db->get_row($sel_query);        
    }
    // получаем значение поля элемента по имени или id поля поля, с учетом типа поля 
    protected function getMessageField($message,$field){
        global $nc_core;
        $ret = '';
        if(is_numeric($field)){
            $field  = $this->getFieldById($field);
        }
        if(empty($message) || empty($field)){
            return '';
        }
        switch(true){
            case (/*$field->TypeOfData_ID == 4 && */$field->TypeOfData_Name == 'Список'):
                $table_name = strstr(trim($field->Format).':',':',true);
                $sel_query = "
                    SELECT 
                        `".$table_name."_Name`
                    FROM `Classificator_".$table_name."` WHERE ".$table_name."_ID = ".$message->{$field->Field_Name};
                $ret = $nc_core->db->get_var($sel_query);
            break;
            default:
                $ret = $message->{$field->Field_Name};
        }
        return strip_tags($ret);
    }
    // генерирует для измененного или добавленного message метатеги
    function makeMessageMetaTags($Catalogue_ID, $Subdivision_ID,$Sub_Class_ID, $Class_ID,$Message_ID){
        global $MODULE_FOLDER,$nc_core;
        $savedSettings = $this->getSevedSettings() ;
        if(!empty($savedSettings[$Class_ID])){
            $message = $this->getMessageById($Class_ID,$Message_ID);
            $text = $this->getMessageField($message,$savedSettings[$Class_ID]);
            try{
                require_once($MODULE_FOLDER.'page_metatags/libraries/morphy.php');
                $this->morphy = new MY_Morphy();    
            }catch(Exception $e){
                exit('Cannot load library');    
            }
            $description = $this->get_description($text);
            $keywords = $this->morphy->getKeywords($text);
            $upd_query = "
                UPDATE `Message".$Class_ID."` 
                SET `ncKeywords` = '".$keywords."', 
                    `ncDescription` = '".$description."' 
                WHERE `Message_ID` = '".$Message_ID."'";
            $nc_core->db->query($upd_query);
        }
    }
    // отдает список классов ,отсортированных по группам, внутри групп - по алфавиту
    protected function getClassList(){
        global $nc_core;
        $sel_query = "
            SELECT Class_ID, Class_Name, Class_Group
            FROM `Class`
            WHERE Class_Group != 'Шаблоны компонентов'
            ORDER BY Class_Group ASC, Class_Name ASC
        ";
        return $nc_core->db->get_results($sel_query); 
    } 
    // отдает список классов ,отсортированных по группам, внутри групп - по алфавиту
    protected function getStructuredClassList(){
        $classList = $this->getClassList() ;
        $ret  = array();
        foreach($classList as $class){
            if(!isset($ret[$class->Class_Group])){
                $ret[$class->Class_Group] = array();    
            }
            $ret[$class->Class_Group][$class->Class_ID] = $class;
        }
        return $ret;
    } 
    // отдает структурированный список полей классов, сгруппированый по Class_ID
    protected function getStructuredFieldsList(){
        $fields = $this->getFieldsList();
        $ret = array();
        foreach($fields as $field){
            if(!isset($ret[$field->Class_ID])){
                $ret[$field->Class_ID] = array();    
            }
            $ret[$field->Class_ID][] = $field;    
        }
        return $ret;    
    }
    //  отдает список вообще всех полей
    protected function getFieldsList(){
        global $nc_core;
        $sel_query = "SELECT * FROM Field" ;
        return  $nc_core->db->get_results($sel_query);
    }
    // отдает массив сохраненных настроек
    protected function getSevedSettings(){
        global $nc_core;
        $sel_query = "SELECT * FROM PageMetatags_Settings" ;
        $res = $nc_core->db->get_results($sel_query);
        $ret = array();
        if(!empty($res)){
            foreach($res as $item){
                $ret[$item->Class_ID] = $item->Field_ID    ;
            }
        }     
        return $ret;
    }
    // получение Message
    protected function getMessageById($Class_ID,$message_ID){
        global $nc_core;
        $sel_query = "SELECT * 
        FROM `Message".$Class_ID."`
        WHERE Message_ID = ".$message_ID;
        return $nc_core->db->get_row($sel_query);
    } 
    // получение description из текста
    protected function get_description($text='',$disallowed=array()){
        $_disallowed = array("\n");
        $_disallowed = array_merge($_disallowed,$disallowed);
        return preg_replace('/\s+/mi',' ',mb_substr(str_replace($_disallowed,'',strip_tags($text)),0,300,'UTF-8'));
    }
    
}
?>